# 函数插件
该插件实现Excel中的PMT，RATE，IRR，XIRR的财务函数；

XIRR函数的功能：计算一组定期或者不定期现金流的内部收益率；
XIRR函数的语法结构：XIRR(values, dates, [guess])，
values为现金流；
dates为现金流相对应的日期；
guess为选填参数，表示预期利率，不填系统默认为10%；
XIRR使用示例：XIRR(A1:A25,B1:B25)或XIRR(A1:A25,B1:B25，0.11)，所选区域支持去空，比如只有24期数据，选择A1:A34也是可以的，但为保证计算结果的准确性，必须保证中间数据是连续的；


IRR函数的功能：计算一组定期现金流的内部收益率；
IRR函数的语法结构：XIRR(values, [guess])。
values为必填参数，表示现金流；
guess为选填参数，表示预期利率，不填系统默认为10%；
IRR使用示例：XIRR(A1:A25)或XIRR(A1:A250.11)，所选区域支持去空，比如只有24期数据，选择A1:A34也是可以的，但为保证计算结果的准确性，必须保证中间数据是连续的；

RATE函数的功能：计算每期年金的利率；
RATE函数的语法结构:RATE(nper, pmt, pv, [fv], [type], [guess]),
nper必填参数,为年金的付款总期数；
pmt必填参数，为每期的付款金额；
pv必填参数，为现值即一系列未来付款当前值的总和；
fv可选参数。 表示未来值，或在最后一次付款后希望得到的现金余额。 如果省略 fv，则假定其值为 0；
type可选参数，用以指定各期的付款时间是在期初还是期末，传值为数字 0-期末 或 1-期初，默认为期末；
guess可选参数，表示预期利率。如果省略 guess，则假定其值为 10%。
RATE函数使用示例：rate(24,14708.05,-315450),在相同条件下贷款的年利率为rate(24,14708.05,-315450)*12


PMT函数的功能：用于根据固定付款额和固定利率计算贷款的付款额；
PMT函数的语法结构:PMT(rate, nper, pv, [fv], [type]);
rate参数必填，表示贷款利率；
nper参数必填，表示该项贷款的付款总数，即期数；
pv参数必填，表示现值，或一系列未来付款额现在所值的总额，也叫本金;
fv可选参数。 表示未来值，或在最后一次付款后希望得到的现金余额。 如果省略 fv，则假定其值为 0；
type可选参数，用以指定各期的付款时间是在期初还是期末，传值为数字 0-期末 或 1-期初，默认为期末；
PMT使用的示例：pmt(0.078/12,24,20000,,1)或pmt(0.078/12,24,20000)












